/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */
#include "pil.h"
#include "pu.h"

#ifndef _CALIB_H_
#define _CALIB_H_

struct CALIBRATIONS {
    PIL_CALIBRATION(int16_t, voltageGain, Q_IV, VDC_REF, "V", 0, 100.0, (3.3/0.0498) * ((double)(R_IV)/1024.0));
    PIL_CALIBRATION(int16_t, currentGain, Q_IV, I_REF, "A", -20.0, 20.0, (-3.3/0.1908) * ((double)(R_IV)/1024.0));

    // current controller gains
    PIL_CALIBRATION(int16_t, KpD, PLX_PIDQ_Q_KP, R_REF, "Ohm", 0.0, 20.0, 13.75);
    PIL_CALIBRATION(int16_t, KiD, PLX_PIDQ_Q_KI, R_REF, "Ohm", 0.0, 20.0, 0.5);
    PIL_CALIBRATION(int16_t, KpQ, PLX_PIDQ_Q_KP, R_REF, "Ohm", 0.0, 20.0, 13.75);
    PIL_CALIBRATION(int16_t, KiQ, PLX_PIDQ_Q_KI, R_REF, "Ohm", 0.0, 20.0, 0.5);

    PIL_CALIBRATION(float, fCalib, 0, 1.0, "", 0.0, 100000.0, 0.5);
};

extern struct CALIBRATIONS Calib;

#endif
