/*
        Copyright (c) 2014 by Plexim GmbH
        All rights reserved.

        A free license is granted to anyone to use this software for any legal
        non safety-critical purpose, including commercial applications, provided
        that:
        1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
        2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
        OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
        SOFTWARE.
 */

/**
 * @file fp_math.h
 * @brief Fixed-point math routines.
 */

#ifndef FP_MATH_H_
#define FP_MATH_H_

#include "plx_types.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int16_t PLX_FPMATH_divide(int16_t aN, int16_t aD, int16_t aQ);
extern int16_t PLX_FPMATH_divideAbsN(int16_t aN, int16_t aD, int16_t aQ);

extern void PLX_FPMATH_lookupSinAndCos(
    uint16_t aAngle, // angleIn, 360 degrees = 65536
    int16_t *aSin, // Sine output, Q15
    int16_t *aCos // Cosine output Q15
    );

extern int16_t PLX_FPMATH_sqrtQ10(int16_t aVal);

#ifdef __cplusplus
}
#endif // extern "C"

#endif /* FP_MATH_H_ */
