/*
        Copyright (c) 2014 by Plexim GmbH
        All rights reserved.

        A free license is granted to anyone to use this software for any legal
        non safety-critical purpose, including commercial applications, provided
        that:
        1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
        2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
        OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
        SOFTWARE.
 */

#include <p33FJ128MC802.h>
#include "pil.h"

// Configuration bits
// Start-up with FRC and switch to FRC w/ Pll
// Configure Watch Dog Timeout (Software Enable/Disable)
// Select ICSP Pair 2 for programming/debugging

_FOSCSEL(FNOSC_FRC)
_FOSC(FCKSM_CSECMD & OSCIOFNC_ON)
_FWDT(FWDTEN_OFF)
_FPOR(FPWRT_PWR128)
_FICD(ICS_PGD3 & JTAGEN_OFF)

struct CTRL_DISPATCH_VARS {
    PIL_READ_PROBE(int16_t, interruptNesting, 0, 1.0, "");
    PIL_READ_PROBE(uint16_t, interruptEndTimeStamp, 0, 1.0, "");
};

extern void initClock(void);
extern void initIOPorts(void);
extern void initTimers(void);
extern void UARTinit();









