/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

#ifndef IO_H_
#define IO_H_

#define ASSERT_RESET_A 	GpioDataRegs.GPACLEAR.bit.GPIO1 = 1
#define RELEASE_RESET_A GpioDataRegs.GPASET.bit.GPIO1 = 1

#define ASSERT_RESET_B 	GpioDataRegs.GPACLEAR.bit.GPIO3 = 1
#define RELEASE_RESET_B GpioDataRegs.GPASET.bit.GPIO3 = 1

#define ASSERT_RESET_C 	GpioDataRegs.GPACLEAR.bit.GPIO5 = 1
#define RELEASE_RESET_C GpioDataRegs.GPASET.bit.GPIO5 = 1

#define START_PRESSED ((GpioDataRegs.GPADAT.all & 0x200) == 0)
#define STOP_PRESSED ((GpioDataRegs.GPADAT.all & 0x80) == 0)

#define TURN_LED1_ON 	GpioDataRegs.GPASET.bit.GPIO12 = 1
#define TURN_LED1_OFF	GpioDataRegs.GPACLEAR.bit.GPIO12 = 1

#define TURN_LED2_ON 	GpioDataRegs.GPASET.bit.GPIO15 = 1
#define TURN_LED2_OFF	GpioDataRegs.GPACLEAR.bit.GPIO15 = 1

#define TURN_LEDSTAT_ON 	GpioDataRegs.GPASET.bit.GPIO22 = 1
#define TURN_LEDSTAT_OFF	GpioDataRegs.GPACLEAR.bit.GPIO22 = 1

#define TURN_LEDCRD_ON 	GpioDataRegs.GPBSET.bit.GPIO34 = 1
#define TURN_LEDCRD_OFF	GpioDataRegs.GPBCLEAR.bit.GPIO34 = 1

extern void initGPIO();

#endif
