/*
 Copyright (c) 2014 by Plexim GmbH
 All rights reserved.

 NOTICE: This software embodies unpublished proprietary
 and trade secret information of Plexim GmbH.  Any copying,
 disclosure or transmission not expressly authorized by
 the owner is expressly prohibited. Plexim GmbH retains exclusive
 ownership of all intellectual property rights in this software,
 including all copyright, trade secret and patent rights.
 */

/**
 * @file pll.h
 * @brief Phase-locked loop.
 */

#ifndef PLL_H_
#define PLL_H_

#include "plx_types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct PLX_PLL_OBJ
{
	int32_t data[23];
} PLX_PLL_Obj_t;

typedef PLX_PLL_Obj_t *PLX_PLL_Handle_t;

extern PLX_PLL_Handle_t PLX_PLL_init(void *aMemory, const size_t aNumBytes);

extern void PLX_PLL_configure(PLX_PLL_Handle_t aPllHandle, int16_t aPuFrefTsScaling,
		int16_t aKp, int16_t aKi, int16_t aOmegaMin, int16_t aOmegaMax,
		uint16_t aLockAngle, uint16_t aLockTicks, uint16_t aUnlockAngle, uint16_t aUnlockTicks);

extern void PLX_PLL_reset(PLX_PLL_Handle_t aPllHandle, int16_t aOmega0);

extern void PLX_PLL_udpate(PLX_PLL_Handle_t aPllHandle, uint16_t aInputAngle,
		uint16_t *aOutputAngle, int16_t *aOmega, bool_t *isLocked);

#ifdef __cplusplus
}
#endif // extern "C"

#endif /* PI_H_ */
