V_gpeak = 110e3/sqrt(3)*sqrt(2); % peak grid phase voltage (V)
f_g = 50; % grid frequency (Hz)

V_dc = 640e3; % DC bus reference voltage sum (V)
num_sm = 38; % number of series cells
V_sm = V_dc/num_sm; % DC capacitor initial voltage (V)
C_sm = 20e-3; % DC bus capacitance (F)
C_sm_vector = C_sm * ones(1, num_sm); % DC bus capacitance vector (F)
V_sm_vector = V_sm * ones(1, num_sm); % DC capacitor initial voltage vector (V)
carrier_min = [0:1/num_sm:(1 - 1/num_sm)]; % Minimum carrier signal values
carrier_max = [1/num_sm:1/num_sm:1]; % Maximum carrier signal values
L_arm = 3e-3; % Filter indutance (Henries)
R_arm = 0.1; % Filter winding resistance (ohms)
L_g = 5e-3; % Grid equivalent inductance (Henries)
R_g = 0.1; % Grid equivalent resitance (ohms)

f_sw = 1000; % Triangle carrier wave frequency (Hz)

% Equivalent parameters for current control calculations
L_f = L_g + L_arm/2;
R_f = R_g + R_arm/2;

% Limitation
I_f_max = 10000; % maximum current (A)

% Current control
alpha_f = 100; % cut off frequency of the PI controller
R_res_a = 1e-3; % Active damping resistance for resonance elimitation
R_gc_a = alpha_f*L_f - R_f; % active damping coefficient
K_gc_pd = alpha_f*L_f; % propotional gain for d-axis
K_gc_id = alpha_f*(R_f + R_gc_a); % integral gain for d-axis
K_gc_pq = alpha_f*L_f; % proportional gain for q-axis
K_gc_iq = alpha_f*(R_f+R_gc_a); % integral gain for q-axis

% DC-link voltage control
K_gc_pW = 0.001; % proportional gain
K_gc_iW = 1; % integral gain
K_gc_b = 10; % anti-windup

T_HIL = 1/f_sw/100; % discretization step-size