%% Simulation
tsim = 0.045;       % [s] - simulation time

%% Electrical
V_DC = 200;         % [V] - DC voltage source
n_prim = 4;         % [] - primary side turn number
n_sndry = 4;        % [] - secondary side turn number

%% Primary side
L_r = 1.55e-6;		% [H] - resonant inductor
C_r = 1.2e-6;		% [F] - resonant capacitor

%% Secondary side
L = 1.6e-6;			% [H] - output inductor
C_o = 480e-6;		% [F] - output capacitor
C_v_init = 0;		% [V] - output capacitor initial voltage
R_o = 100;			% [Ohm] - output resistance

%% Controller
sys_clk = 100e6;	% [Hz] - 100 MHz
max_period = 2000;	% Maximum system period allowed
min_period = 200;	% Maximum system period allowed

%% Voltage change control
SlewStep = 0.25/3;  % [V/ms] - slew rate
StartUpInc = 100;   % [] - soft start frequency increment

%% Sensing
R1 = 4700/4;        % [Ohm] - sensing resistor
R2 = 160/24;        % [Ohm] - sensing resistor
C_sense = 10e-9;    % [F] - sensing capacitor

%% ADC conversion time
adc_conv = 15;      % [] - Number of system clock cycles required for ADC conversion

%% Dead time
T_dt = 300e-9;      % [s] - dead time