V_gpeak = 15e3/sqrt(3)*sqrt(2); % peak grid phase voltage (V)
f_g = 50; % grid frequency (Hz)
V_dc = 15e3; % DC bus reference voltage sum (V)
num_sm = 9; % number of series cells
config = 1; % power module configuration (switched=1, averaged=2)
V_sm = V_dc/num_sm; % DC capacitor initial voltage (V)
C_sm = 5e-3; % DC bus capacitance (F)
L_arm = 10e-3; % Filter indutance (Henries)
R_arm = 0.1; % Filter winding resistance (ohms)
L_g = 5e-3; % Grid equivalent inductance (Henries)
R_g = 0.1; % Grid equivalent resitance (ohms)

f_sw = 300; % Triangle carrier wave frequency (Hz)

% Limitation
I_f_max = 2000; % maximum current (A)

% Current control
alpha_f = 500; % cut off frequency of the PI controller
R_gc_a = alpha_f*L_arm - R_arm; % active damping coefficient
K_gc_pd = alpha_f*L_arm; % propotional gain for d-axis
K_gc_id = alpha_f*(R_arm + R_gc_a); % integral gain for d-axis
K_gc_pq = alpha_f*L_arm; % proportional gain for q-axis
K_gc_iq = alpha_f*(R_arm+R_gc_a); % integral gain for q-axis

% DC-link voltage control
K_gc_pW = -2; % proportional gain
K_gc_iW = -30; % integral gain
K_gc_b = 10; % for anti-windup