#ifndef PLECSRTW_H_
#define PLECSRTW_H_

typedef struct {
   const unsigned numX, numY, numZ;
   const double *xVec, *yVec, *zVec, *data;
   unsigned xIdx, yIdx, zIdx;
} plecsLUT;

extern double plecsmax(double, double);

extern double plecsmin(double, double);

extern double plecsmod(double, double);

extern double plecslu1d(plecsLUT *, double);

extern double plecslu2d(plecsLUT *, double, double);

extern double plecslu3d(plecsLUT *, double, double, double);

struct CScriptStruct
{
   int numInputTerminals;
   int numOutputTerminals;
   int* numInputSignals;
   int* numOutputSignals;
   int numContStates;
   int numDiscStates;
   int numZCSignals;
   int numSampleTimes;
   int numParameters;
   int isMajorTimeStep;
   double time;
   const double ***inputs;
   double ***outputs;
   double *contStates;
   double *contDerivs;
   double *discStates;
   double *zCSignals;
   const int *paramNumDims;
   const int **paramDims;
   const int *paramNumElements;
   const double **paramRealData;
   const char **paramStringData;
   const char * const *sampleHits;
   const double *sampleTimePeriods;
   const double *sampleTimeOffsets;
   double *nextSampleHit;
   const char** errorStatus;
   const char** warningStatus;
   const char** rangeErrorMsg;
   int* rangeErrorLine;
};

#endif
